/*********** autounsub.c
	    Handler of automatic unsubscribe feature
		Written by Gabor Paller
			    ***********/
			    
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	"config.h"

static char	fbuf[N_BUFSIZE+1];

/* This is the routine that finds out if the letter
   is an error letter sent back by a mailer daemon
   because the address doesn't exist anymore. Unfortunately
   this part is rather heuristic as the format of the
   error letter depends highly on the mailer daemon.
   Nlist is prepared for qmail, sendmail, PMDF, Notes and Exchange 
   daemons.
   
   The routine gets the name of the letter file
   and the starting offset of the content in it */
char *handle_autounsubscribe( char letterfile[], long contentptr ) {
  static char return_value[N_BUFSIZE];
  FILE *tempfile;
  int	huntforaddress = 0;
  char	*p,*p1;
  
  *return_value = 0;
  if( ( tempfile = fopen( letterfile,"r" ) ) == NULL )
      return NULL;
/* First check the headers */ 
  while( fgets( fbuf, N_BUFSIZE, tempfile ) != NULL ) {
    if( *fbuf == '\n' )
    	break;		/* Empty line, end of header section */
    if( strncmp( fbuf,"X-Failed-Recipients",19 ) == 0 ) {
      if( strlen( fbuf ) < 21 ) {		/* Simple paranoia ... */
        fclose( tempfile );
      	return NULL;
      }
      p = fbuf+21;
/* Cut down training newline and spaces, meanwhile check, if there were
   multiple failed recipients. We return only the first */
      while( *p ) {
        if( ( *p == ' ' ) || ( *p == ',' ) || ( *p == '\n' ) ) {
          *p = 0;
          break;
        }
        ++p;
      }
      strcpy( return_value,fbuf+21 );
      fclose( tempfile );
      return return_value;
    }
  }
  rewind( tempfile );
  while( fgets( fbuf,N_BUFSIZE,tempfile ) != NULL ) {
    if( *fbuf == '\n' )
	continue;
/* Check for MTA error signatures */
/* User address is in the same line as the error signature */
/* Postfix */
    if( ( strstr( fbuf,"output: User not" ) != NULL ) ||
/* Sendmail (?) */
        ( strstr( fbuf,"unrecoverable error" ) != NULL ) ) {
      huntforaddress = 1;
      goto look_address;
    }
    else
    if(
/* User address follows error signature */
/* Sendmail */
        ( strstr( fbuf,"permanent fatal errors" ) != NULL ) ||
/* qmail */
        ( strstr( fbuf,"I wasn't able to deliver your message" ) != NULL ) ||
/* qmail again */
	( strstr( fbuf,"This is a permanent error" ) != NULL ) ||
/* Exchange */
        ( strstr( fbuf,"did not reach the following recipient" ) != NULL ) ||
/* Notes */
        ( strstr( fbuf, "was not delivered to:" ) != NULL ) ||
/* PMDF */
        ( strstr( fbuf, 
          "Your message cannot be delivered to the following recipients:" ) != NULL )
      )
	    huntforaddress = 1;
    else
      if( strstr( fbuf,"non-fatal errors" ) != NULL )
	    huntforaddress = 2;
    else
    if( huntforaddress ) {
look_address:
/* Let's analyze the address. We tokenize the line
   until we find something that looks like an e-mail address */
      p1 = fbuf;
      while( ( p = strtok( p1," \t\n<>" ) ) != NULL ) {
        if( strchr( p,'@' ) != NULL )
        	break; 
        p1 = NULL;
      }
/* Check if there is any problem with the address. Forget
   it if there is. */
      if( ( p != NULL ) && ( *p != 0 ) && ( strchr( p,'@' ) != NULL ) ) {
        if( huntforaddress == 2 ) {
	  *return_value = 1;
	  strcpy( return_value+1,p ); 
	} else
	    strcpy( return_value,p );
	break;
      }
      continue;
    }
  }
  fclose( tempfile );
  if( *return_value == 0 )
      return NULL;
  return return_value;
}
